package net.shadowfacts.phycon.init

import net.minecraft.block.Block
import net.minecraft.util.Identifier
import net.minecraft.util.registry.Registry
import net.shadowfacts.phycon.network.block.cable.CableBlock
import net.shadowfacts.phycon.network.block.extractor.ExtractorBlock
import net.shadowfacts.phycon.network.block.miner.MinerBlock
import net.shadowfacts.phycon.network.block.netinterface.InterfaceBlock
import net.shadowfacts.phycon.network.block.netswitch.SwitchBlock
import net.shadowfacts.phycon.network.block.terminal.TerminalBlock
import net.shadowfacts.phycon.network.block.test.DestBlock
import net.shadowfacts.phycon.network.block.test.SourceBlock

/**
 * @author shadowfacts
 */
object PhyBlocks {

	val INTERFACE = InterfaceBlock()
	val TERMINAL = TerminalBlock()
	val SWITCH = SwitchBlock()
	val CABLE = CableBlock()
	val EXTRACTOR = ExtractorBlock()
	val MINER = MinerBlock()

	val SOURCE = SourceBlock()
	val DEST = DestBlock()

	fun init() {
		register(InterfaceBlock.ID, INTERFACE)
		register(TerminalBlock.ID, TERMINAL)
		register(SwitchBlock.ID, SWITCH)
		register(CableBlock.ID, CABLE)
		register(ExtractorBlock.ID, EXTRACTOR)
		register(MinerBlock.ID, MINER)

		register(SourceBlock.ID, SOURCE)
		register(DestBlock.ID, DEST)
	}

	private fun register(id: Identifier, block: Block) {
		Registry.register(Registry.BLOCK, id, block)
	}

}
