package net.shadowfacts.phycon.init

import net.minecraft.item.BlockItem
import net.minecraft.item.Item
import net.minecraft.util.Identifier
import net.minecraft.util.registry.Registry
import net.shadowfacts.phycon.item.ConsoleItem
import net.shadowfacts.phycon.item.ScrewdriverItem
import net.shadowfacts.phycon.network.block.cable.CableBlock
import net.shadowfacts.phycon.network.block.extractor.ExtractorBlock
import net.shadowfacts.phycon.network.block.miner.MinerBlock
import net.shadowfacts.phycon.network.block.netinterface.InterfaceBlock
import net.shadowfacts.phycon.network.block.netswitch.SwitchBlock
import net.shadowfacts.phycon.network.block.terminal.TerminalBlock
import net.shadowfacts.phycon.network.block.test.DestBlock
import net.shadowfacts.phycon.network.block.test.SourceBlock

/**
 * @author shadowfacts
 */
object PhyItems {

	val INTERFACE = BlockItem(PhyBlocks.INTERFACE, Item.Settings())
	val TERMINAL = BlockItem(PhyBlocks.TERMINAL, Item.Settings())
	val SWITCH = BlockItem(PhyBlocks.SWITCH, Item.Settings())
	val CABLE = BlockItem(PhyBlocks.CABLE, Item.Settings())
	val EXTRACTOR = BlockItem(PhyBlocks.EXTRACTOR, Item.Settings())
	val MINER = BlockItem(PhyBlocks.MINER, Item.Settings())

	val SOURCE = BlockItem(PhyBlocks.SOURCE, Item.Settings())
	val DEST = BlockItem(PhyBlocks.DEST , Item.Settings())

	val SCREWDRIVER = ScrewdriverItem()
	val CONSOLE = ConsoleItem()

	fun init() {
		register(InterfaceBlock.ID, INTERFACE)
		register(TerminalBlock.ID, TERMINAL)
		register(SwitchBlock.ID, SWITCH)
		register(CableBlock.ID, CABLE)
		register(ExtractorBlock.ID, EXTRACTOR)
		register(MinerBlock.ID, MINER)

		register(SourceBlock.ID, SOURCE)
		register(DestBlock.ID, DEST)

		register(ScrewdriverItem.ID, SCREWDRIVER)
		register(ConsoleItem.ID, CONSOLE)
	}

	private fun register(id: Identifier, item: Item) {
		Registry.register(Registry.ITEM, id, item)
	}

}
