package net.shadowfacts.phycon.network.block.test

import net.minecraft.util.math.Direction
import net.shadowfacts.phycon.api.Interface
import net.shadowfacts.phycon.api.packet.Packet
import net.shadowfacts.phycon.init.PhyBlockEntities
import net.shadowfacts.phycon.network.DeviceBlockEntity
import net.shadowfacts.phycon.network.NetworkUtil

/**
 * @author shadowfacts
 */
class DestBlockEntity: DeviceBlockEntity(PhyBlockEntities.DEST) {

	override fun handle(packet: Packet) {
		println("$this ($ipAddress) received packet: $packet")
	}

	override fun findDestination(): Interface? {
		for (dir in Direction.values()) {
			val itf = NetworkUtil.findConnectedInterface(world!!, pos, dir)
			if (itf != null) {
				return itf
			}
		}
		return null
	}

}